<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>Chapter&nbsp;2.&nbsp;Run the Demo</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.2  (Linux)">
	<META NAME="CREATED" CONTENT="20080725;15280900">
	<META NAME="CHANGEDBY" CONTENT="Vincent Mahe">
	<META NAME="CHANGED" CONTENT="20080725;15280900">
	<STYLE TYPE="text/css">
	<!--
		@page { size: 21cm 29.7cm; margin: 2cm }
		P { margin-bottom: 0.21cm }
		H3 { margin-bottom: 0.21cm }
		H2 { margin-bottom: 0.21cm }
		H1 { margin-bottom: 0.21cm }
		H1.western { font-family: "Nimbus Roman No9 L", serif }
		H1.cjk { font-family: "Nimbus Sans L" }
		H1.ctl { font-family: "Lucidasans" }
	-->
	</STYLE>
</HEAD>
<BODY LANG="fr-FR" BGCOLOR="#ffffff" DIR="LTR">
<H1 CLASS="western">Chapter&nbsp;2.&nbsp;Run the Demo</H1>
<H2>Goal of the demo</H2>
<P>The goal of the demo is to show you an application of OpenEmbeDD
tools suite using three very important components/tasks the platform
is based on: a <U>model graphic editor</U>, a <SPAN STYLE="font-style: normal"><U>model
transformation</U></SPAN> and a <U>model simulator</U>. The
implementation order of the demo is arbitrary. You can use each of
three tools alone or in another order and another way according to
your specific process and needs.</P>
<P>The example is based on two well known metamodels: <STRONG>UML2</STRONG>
and <STRONG>CWM</STRONG> (for Common Warehouse Metamodel). We choose
them to offer you a vision of the OpenEmbeDD ability to deal with
<EM>industrial metamodels</EM> when other platforms use academic
(toys) metamodels.</P>
<P>However, for a quickly understable presentation, we have
considered only a few part of each metamodel, using only basics of
the UML2 <STRONG>class diagram</STRONG> and the <STRONG>relational</STRONG>
package of CWM metamodel (which contains DataBase concepts like
table, key, index,…).</P>
<H3 LANG="en">Schema of the demo</H3>
<P ALIGN=CENTER><IMG SRC="../img/schema.png" NAME="graphics3" ALIGN=LEFT WIDTH=529 HEIGHT=381 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<H3 LANG="en">Specifications</H3>
<OL>
	<LI><P LANG="en">First, we wish to be able to build a simple<SPAN LANG="en">
	UML2</SPAN> model (class diagram). Of course we have to limit our
	target because the demo would become very complex and less teaching
	if there are to many concepts implied in the model. However we wish
	to manage multi-property for the class and two association types :
	0.1 - * and * - *, in order to be able to simulate (simple) queries.</P>
	<P LANG="en">We also wish to facilitate each UML model with the
	graphic editor provided by Topcased.</P>
	<P LANG="en">UML2 sampling:</P>
	<UL TYPE=DISC>
		<LI><P LANG="en">management of the data type</P>
		<LI><P LANG="en">management of the multiple properties for a class</P>
		<LI><P LANG="en">management of the class type multiple</P>
		<LI><P LANG="en">management of associations 0.1 - * and with one
		composite</P>
		<LI><P LANG="en">management of associations * - *</P>
	</UL>
	<LI><P LANG="en">Second, we would like to take the model UML above
	as input and transform it into a relational database model for which
	we know one metamodel : the CWM (Common Wharehouse Metamodel). We
	are choose a simple example for the mapping between two reduced
	parts of the metamodels:</P>
	<UL TYPE=DISC>
		<LI><P LANG="en">the UML static model is mapped as a CWM root
		Catalog</P>
		<LI><P LANG="en">the container Package corresponds to a Schema</P>
		<LI><P LANG="en">a Class corresponds to a Table</P>
		<LI><P LANG="en">a Data Type corresponds to a SQLStructuredType</P>
		<LI><P LANG="en">a property corresponds to a set of Table and
		ForeignKey according to its multiplicity and its type</P>
		<LI><P LANG="en">an association corresponds to a set of Table and
		ForeignKey according to its multiplicity and its composite</P>
	</UL>
	<LI><P LANG="en">Third, we would like to simulate the result of CWM
	model by inserting elements in the Tables; it corresponds to the
	simulation of an instance of the model CWM. We only implemented the
	simplest functions:</P>
	<UL TYPE=DISC>
		<LI><P LANG="en">print a table content</P>
		<LI><P LANG="en">add a row</P>
		<LI><P LANG="en">delete a row</P>
		<LI><P LANG="en">select rows in a table, on a foreign key</P>
	</UL>
</OL>
<H2>FIRST STEP : UML diagram (with TOPCASED)</H2>
<P>If you wish to use the graphic editor of topcased to design the
UML models input, you must initially  ensure that it is well
installed in your OpenEmbeDD platform.</P>
<P>We are beginning the demo with a UML model using the class diagram
editor of Topcased. You can use the model provided in the demo for a
first use (you may later build one yourself by launching the UML
graphic editor: File-&gt;New-&gt;Other then select &quot;UML Diagram&quot;
in the &quot;Topcased/Topcased Diagrams&quot; directory).</P>
<P>The name of the given file is <STRONG>SalesRDB.umldi</STRONG> for
the diagram and <STRONG>SalesRDB.uml</STRONG> for the underlying UML
model. You can find them in the directory named &quot;model&quot; at
the root of the project <STRONG>org.openembedd.basic.uml2cwm.demo</STRONG>.
The file SalesRDB.uml is the input model for second step
transformation towards a CWM model. After studying this given example
we encourage you to build your own models by the same mechanism and
to test them in the second step.</P>
<P>Here is the example of SalesRDB input model we provide :</P>
<P><IMG SRC="../img/topcased_diagram_example.png" NAME="graphics4" ALIGN=LEFT WIDTH=675 HEIGHT=387 BORDER=0><BR CLEAR=LEFT>As
soon as you modify the diagram SalesRDB.umldi and you save it, your
modifications will be effective in the SalesRDB.uml model file; on
the other hand the opposite is not true. Also note that if you remove
graphic objects on the *.umldi diagram, you should choice the
&quot;shift+delete&quot; action in order to also remove them in the
*.uml model itself.</P>
<P>You can have a look on the SalesRDB.uml  modelwith the reflexive
editor of EMF : in this way it looks like a tree.</P>
<P ALIGN=CENTER><IMG SRC="../img/topcased_umlecore_example.png" NAME="graphics5" ALIGN=LEFT WIDTH=299 HEIGHT=492 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<H2>SECOND STEP : transformation from UML to CWM (with ATL)</H2>
<P>The second stage of the demo is to transform the UML SalesRDB.uml
model seen previously into a CWM relational model following our
specification seen in 2.1.</P>
<P>The file's name of ATL transformation is
<STRONG>umlclass2cwmrelational.atl</STRONG> and you can find it in
the folder named &quot;atl&quot;. An ATL file has the *.atl
extension, and contains a set of rules and helpers which correspond
to the mapping of the transformation of a source metamodel (UML) and
destination metamodel (CWM). The ATL transformation file exists in
the demonstration project. You can modify it for your tests, after
keeping a copy somewhere in your project (in any way you will be able
to always reinstall the demonstration if necessary).</P>
<P>The first thing to do is to set up the ATL launch configurator to
allow the transformation to run.</P>
<P><IMG SRC="../img/ATL_launch_configuration.png" NAME="graphics6" ALIGN=LEFT WIDTH=642 HEIGHT=311 BORDER=0><BR CLEAR=LEFT>You
may launch the run dialog on the menu Run-&gt;Run... In the treeview
on the left you can see a set of application type including ATL
transformation. It should exist one ATL configuration named by
&quot;<STRONG>uml2cwm</STRONG>&quot; like in the screenshot below:</P>
<P>Select it and run it to get the <STRONG>SalesRDB.relational</STRONG>
out file.</P>
<P>If you meet some problems then see has the following address :
<A HREF="http://www.eclipse.org/m2m/atl/doc/ATL_Starter_Guide.pdf">http://www.eclipse.org/m2m/atl/doc/ATL_Starter_Guide.pdf</A>
where there is a starter guide which works step by step with a lot of
details.</P>
<P>The result of the transformation is a CWM relational model which
one can publish with the reflexive editor EMF because its plugin is
provided with the demo. The result of the transformation of
SalesRDB.uml is called &quot;<B>SalesRDB.relational</B>&quot; and
looks like below :</P>
<P ALIGN=CENTER><IMG SRC="../img/ATL_result_out_relational.png" NAME="graphics7" ALIGN=LEFT WIDTH=410 HEIGHT=430 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<P>You may modify the names of the input and output model files of
the demo in order to use your own models, but you must then modify in
the same way the configurator parameters. On the other hand, the URI
of the metamodels do not need to be changed.</P>
<H2>THIRD STEP : CWM simulator (with Kermeta)</H2>
<P>Now, the last stage is to simulate an instance of the model CWM
resulting from transformation ATL with the Kermeta workbench. The
transformation generated before becomes the input of our CWM
simulator.</P>
<P>A prerequisite is the name of the *.relational input file: that
must be “SalesRDB.relational”. If you want used an other name,
then you must change the code which load the model file in the
Kermeta source <FONT FACE="Courier, monospace">cwm.kmt</FONT> at the
line</P>
<P>	<FONT FACE="Courier, monospace">loadCatalog(&quot;../model/SalesRDB.relational&quot;)</FONT>.</P>
<P>There are four source files for the Kermeta part. You can find
them in the directory “kermeta” which is at the root of the
org.openembedd.basic.uml2cwm.demo project. The files are as follows :</P>
<UL TYPE=DISC>
	<LI><P><STRONG>simulator.kmt</STRONG> : generic simulator textual UI</P>
	<LI><P><STRONG>cwm_simulator.kmt</STRONG> : (very simple) CWM
	simulator for the demo which creates and manipulates an instance of
	the given CWM model</P>
	<LI><P><STRONG>rdb_utils.kmt</STRONG> : classes and methods
	utilities for the CWM simulator</P>
	<LI><P><STRONG>cwm.kmt</STRONG> : launcher of the CWM simulator</P>
</UL>
<P>To launch the simulator, right-click on the &quot;cwm.kmt&quot;
file within the &quot;kermeta&quot; directory and select the sub-menu
&quot;Run As...&quot; in the contextual menu.</P>
<P>Then choose the item &quot;Kermeta App&quot; what causes launching
of Kermeta application on our model &quot;CWM relational&quot; (You
can also use the predefined launch configuration, like for the ATL
transformation).</P>
<P ALIGN=CENTER><IMG SRC="../img/Kermeta_launch_simulation.png" NAME="graphics8" ALIGN=LEFT WIDTH=570 HEIGHT=515 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<P>After the simulator started you can follow the instructions which
appear on the console view and interact with that console to add,
remove and print rows of the model tables.</P>
<P><IMG SRC="../img/Kermeta_simulation_launched.png" NAME="graphics9" ALIGN=LEFT WIDTH=372 HEIGHT=390 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<P>Here is an example suite:</P>
<UL TYPE=DISC>
	<LI><P>add customers</P>
</UL>
<P ALIGN=CENTER><IMG SRC="../img/Kermeta_simulation_AddCustomer.png" NAME="graphics10" ALIGN=LEFT WIDTH=425 HEIGHT=685 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<UL TYPE=DISC>
	<P>For the purpose of the simulation, you should create some other
	customers:</P>
	<UL TYPE=CIRCLE>
		<LI><P>&quot;5, Place Vaucanson&quot;, Durand, 000002</P>
		<LI><P>&quot;18, Rue des Carmes&quot;, Duchemin, 000003</P>
	</UL>
	<LI><P>add products</P>
</UL>
<P ALIGN=CENTER><IMG SRC="../img/Kermeta_simulation_AddProduct.png" NAME="graphics11" ALIGN=LEFT WIDTH=425 HEIGHT=716 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<UL TYPE=DISC>
	<P>Like for consumers, you should create some other products:</P>
	<UL TYPE=CIRCLE>
		<LI><P>XT16, &quot;another modelling tool&quot;, 0002</P>
		<LI><P>ZB32, &quot;low power models transformer&quot;, 0003</P>
	</UL>
	<LI><P>add orders</P>
</UL>
<P ALIGN=CENTER><IMG SRC="../img/Kermeta_simulation_AddOrder.png" NAME="graphics12" ALIGN=LEFT WIDTH=425 HEIGHT=741 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<P>	Like for other tables, you are encouraged to add some orders:</P>
<UL TYPE=DISC>
	<UL TYPE=CIRCLE>
		<LI VALUE=1><P>1 / .T. / 000002 / 003 / 000000000002 (1 ZB32
		delivered to Durand)</P>
		<LI><P>5 / .F. / 000001 / 003 / 000000000003 (5 ZB32 to be
		delivered to Dupont)</P>
	</UL>
	<LI><P>select Dupont's orders</P>
</UL>
<P ALIGN=CENTER><IMG SRC="../img/Kermeta_simulation_SelOrder.png" NAME="graphics13" ALIGN=LEFT WIDTH=425 HEIGHT=651 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<UL TYPE=DISC>
	<LI VALUE=1><P>select orders for ZB32 product</P>
</UL>
<P ALIGN=CENTER><IMG SRC="../img/Kermeta_simulation_SelOrder2.png" NAME="graphics14" ALIGN=LEFT WIDTH=425 HEIGHT=651 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<UL TYPE=DISC>
	<LI VALUE=1><P>delete an order</P>
</UL>
<P ALIGN=CENTER><IMG SRC="../img/Kermeta_simulation_DelOrder.png" NAME="graphics15" ALIGN=LEFT WIDTH=425 HEIGHT=807 BORDER=0><BR CLEAR=LEFT><BR><BR>
</P>
<P>Type exit to stop simulation.</P>
<P>Now that you are familiarized with the basic demo, you can look at
the code to understand how the tools work, and make your own
transformation of model, as declaratory or imperative way, as well as
simulations, or UML and Ecore diagrams with the editors of Topcased.</P>
</BODY>
</HTML>